// ---------------------------------------------------------------------------
// move.cs -- Version 1.3 -- October 28, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Adds events to the movement keys
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\move.cs", "1.3", "Lorne Laliberte", "Oct 28, 2000");

include("writer\\event.cs");
include("writer\\save.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_move.cs file

// Add events to the movement keys

    // Press key to run forward
    //bind(keyboard0, make, "w", to, "ForwardPressed();");
    //bind(keyboard0, break, "w", to, "ForwardReleased();");

    // Press key to run left
    //bind(keyboard0, make, "a", to, "LeftPressed();");
    //bind(keyboard0, break, "a", to, "LeftReleased();");

    // Press key to run back
    //bind(keyboard0, make, "s", to, "BackPressed();");
    //bind(keyboard0, break, "s", to, "BackReleased();");

    // Press key to run right
    //bind(keyboard0, make, "d", to, "RightPressed();");
    //bind(keyboard0, break, "d", to, "RightReleased();");

// ---------------------------------------------------------------------------

WriterPrefs::load("move");

function ForwardPressed()
{
    Event::Trigger(eventForwardPressed);

    if( !Event::Returned(eventForwardPressed, mute) )
    {
        postAction(2048, IDACTION_MOVEFORWARD, 1.0);
        Event::Trigger(eventForwardStarted);
    }
}


function ForwardReleased()
{
    Event::Trigger(eventForwardReleased);

    if( !Event::Returned(eventForwardReleased, mute) )
    {
        postAction(2048, IDACTION_MOVEFORWARD, 0.0);
        Event::Trigger(eventForwardStopped);
    }
}


function BackPressed()
{
    Event::Trigger(eventBackPressed);

    if( !Event::Returned(eventBackPressed, mute) )
    {
        postAction(2048, IDACTION_MOVEBACK, 1.0);
        Event::Trigger(eventBackStarted);
    }
}


function BackReleased()
{
    Event::Trigger(eventBackReleased);

    if( !Event::Returned(eventBackReleased, mute) )
    {
        postAction(2048, IDACTION_MOVEBACK, 0.0);
        Event::Trigger(eventBackStopped);
    }
}


function LeftPressed()
{
    Event::Trigger(eventLeftPressed);

    if( !Event::Returned(eventLeftPressed, mute) )
    {
        postAction(2048, IDACTION_MOVELEFT, 1.0);
        Event::Trigger(eventLeftStarted);
    }
}


function LeftReleased()
{
    Event::Trigger(eventLeftReleased);

    if( !Event::Returned(eventLeftReleased, mute) )
    {
        postAction(2048, IDACTION_MOVELEFT, 0.0);
        Event::Trigger(eventLeftStopped);
    }
}


function RightPressed()
{
    Event::Trigger(eventRightPressed);

    if( !Event::Returned(eventRightPressed, mute) )
    {
        postAction(2048, IDACTION_MOVERIGHT, 1.0);
        Event::Trigger(eventRightStarted);
    }
}


function RightReleased()
{
    Event::Trigger(eventRightReleased);

    if( !Event::Returned(eventRightReleased, mute) )
    {
        postAction(2048, IDACTION_MOVERIGHT, 0.0);
        Event::Trigger(eventRightStopped);
    }
}

function move::save()
{
    AddExportText("    // Press key to run forward");

    ExportBind("ForwardPressed();", "//bind(keyboard0, make, \"w\", TO, \"ForwardPressed();\");");
    ExportBind("ForwardReleased();", "//bind(keyboard0, break, \"w\", TO, \"ForwardReleased();\");");

    AddExportText("");
    AddExportText("    // Press key to run left");

    ExportBind("LeftPressed();", "//bind(keyboard0, make, \"a\", TO, \"LeftPressed();\");");
    ExportBind("LeftReleased();", "//bind(keyboard0, break, \"a\", TO, \"LeftReleased();\");");

    AddExportText("");
    AddExportText("    // Press key to run back");

    ExportBind("BackPressed();", "//bind(keyboard0, make, \"s\", TO, \"BackPressed();\");");
    ExportBind("BackReleased();", "//bind(keyboard0, break, \"s\", TO, \"BackReleased();\");");

    AddExportText("");
    AddExportText("    // Press key to run right");

    ExportBind("RightPressed();", "//bind(keyboard0, make, \"d\", TO, \"RightPressed();\");");
    ExportBind("RightReleased();", "//bind(keyboard0, break, \"d\", TO, \"RightReleased();\");");
}

WriterPrefs::save("move");

function move::init()
{
    needs("writer\\move.cs", "writer\\event.cs 2.7",
                             "writer\\save.cs 2.3");
}
Event::Attach(writerInit, "move::init();");

if(!$UsingWriterLoader) move::init();
